from zope import interface

from plone.portlets.interfaces import IPortletDataProvider
from plone.app.portlets.portlets import base


from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from collective.categories.backend import get_backend

#from collective.portlet.categories import CategoriesPortletMessageFactory as _


class ICategoriesPortlet(IPortletDataProvider):
    """A portlet

    It inherits from IPortletDataProvider because for this portlet, the
    data that is being rendered and the portlet assignment itself are the
    same.
    """


class Assignment(base.Assignment):
    """Portlet assignment.

    This is what is actually managed through the portlets UI and associated
    with columns.
    """

    interface.implements(ICategoriesPortlet)

    def __init__(self):
        pass

    @property
    def title(self):
        """This property is used to give the title of the portlet in the
        "manage portlets" screen.
        """
        return "Categories Portlet"


class Renderer(base.Renderer):
    """Portlet renderer.

    This is registered in configure.zcml. The referenced page template is
    rendered, and the implicit variable 'view' will refer to an instance
    of this class. Other methods can be added and referenced in the template.
    """

    render = ViewPageTemplateFile('categoriesportlet.pt')

    def categories(self):
        backend = get_backend(self.context)
        return backend.get_categories()


class AddForm(base.NullAddForm):
    """Portlet add form.
    """
    def create(self):
        return Assignment()
